My Project: dgConstraint Class Reference

My Project

Classes | Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
dgConstraint Class Referenceabstract

`#include <dgConstraint.h>`

Inheritance diagram for dgConstraint:

## Classes

class | dgPointParam

## Public Types

enum | dgConstraintID { m_ballConstraint, m_hingeConstraint, m_sliderConstraint, m_contactConstraint, m_upVectorConstraint, m_universalConstraint, m_corkScrewConstraint, m_unknownConstraint }

## Public Member Functions

dgUnsigned32 | GetId () const
dgBody * | GetBody0 () const
dgBody * | GetBody1 () const
void | SetBodies (dgBody *const body0, dgBody *const body1)
dgBodyMasterListRow::dgListNode * | GetLink0 () const
dgBodyMasterListRow::dgListNode * | GetLink1 () const
void * | GetUserData () const
bool | IsActive () const
bool | IsCollidable () const
virtual void | ResetMaxDOF ()
dgInt32 | GetMaxDOF () const
void | SetUserData (void *userData)
void | SetCollidable (bool state)
virtual void | SetDestructorCallback (OnConstraintDestroy destructor)=0
virtual dgFloat32 | GetStiffness () const
virtual void | SetStiffness (dgFloat32 stiffness)
virtual void | GetInfo (dgConstraintInfo *const info) const

## Protected Member Functions

| dgConstraint ()
virtual | ~dgConstraint ()
virtual bool | IsBilateral () const
virtual dgUnsigned32 | JacobianDerivative (dgContraintDescritor &params)=0
virtual void | JointAccelerations (dgJointAccelerationDecriptor *const params)=0
virtual void | JointVelocityCorrection (dgJointAccelerationDecriptor *const params)=0
void | SetUpdateFeedbackFunction (ConstraintsForceFeeback function)
void | InitPointParam (dgPointParam &param, dgFloat32 stiffness, const dgVector &p0Global, const dgVector &p1Global) const
void | InitInfo (dgConstraintInfo *const info) const

## Protected Attributes

void * | m_userData
dgBody * | m_body0
dgBody * | m_body1
dgBodyMasterListRow::dgListNode * | m_link0
dgBodyMasterListRow::dgListNode * | m_link1
ConstraintsForceFeeback | m_updaFeedbackCallback
dgUnsigned32 | m_dynamicsLru
dgUnsigned32 | m_index
dgUnsigned32 | m_maxDOF: 6
dgUnsigned32 | m_constId: 6
dgUnsigned32 | m_enableCollision: 1
dgUnsigned32 | m_useExactSolver: 1
dgUnsigned32 | m_solverActive: 1
dgUnsigned32 | m_contactActive: 1

## Friends

class | dgWorld
class | dgAmpInstance
class | dgJacobianMemory
class | dgBodyMasterList
class | dgWorldDynamicUpdate
class | dgParallelSolverJointAcceleration
class | dgParallelSolverInitFeedbackUpdate
class | dgParallelSolverBuildJacobianMatrix
class | dgBroadPhaseMaterialCallbackWorkerThread

## Member Enumeration Documentation

## § dgConstraintID

enum dgConstraint::dgConstraintID

Enumerator
m_ballConstraint |
m_hingeConstraint |
m_sliderConstraint |
m_contactConstraint |
m_upVectorConstraint |
m_universalConstraint |
m_corkScrewConstraint |
m_unknownConstraint |

## Constructor & Destructor Documentation

## § dgConstraint()

dgConstraint::dgConstraint | ( |  | ) |

inlineprotected

## § ~dgConstraint()

dgConstraint::~dgConstraint | ( |  | ) |

inlineprotectedvirtual

## Member Function Documentation

## § GetBody0()

dgBody * dgConstraint::GetBody0 | ( |  | ) | const

inline

## § GetBody1()

dgBody * dgConstraint::GetBody1 | ( |  | ) | const

inline

## § GetId()

dgUnsigned32 dgConstraint::GetId | ( |  | ) | const

inline

## § GetInfo()

void dgConstraint::GetInfo | ( | dgConstraintInfo *const | info | ) | const

virtual

Reimplemented in dgContact, NewtonUserJoint, dgUserConstraint, and dgDeformableContact.

## § GetLink0()

dgBodyMasterListRow::dgListNode * dgConstraint::GetLink0 | ( |  | ) | const

inline

## § GetLink1()

dgBodyMasterListRow::dgListNode * dgConstraint::GetLink1 | ( |  | ) | const

inline

## § GetMaxDOF()

dgInt32 dgConstraint::GetMaxDOF | ( |  | ) | const

inline

## § GetStiffness()

dgFloat32 dgConstraint::GetStiffness | ( |  | ) | const

inlinevirtual

Reimplemented in dgBilateralConstraint.

## § GetUserData()

void * dgConstraint::GetUserData | ( |  | ) | const

## § InitInfo()

void dgConstraint::InitInfo | ( | dgConstraintInfo *const | info | ) | const

protected

## § InitPointParam()

void dgConstraint::InitPointParam | ( | dgPointParam & | param,
|  | dgFloat32 | stiffness,
|  | const dgVector & | p0Global,
|  | const dgVector & | p1Global
| ) |  | const

protected

## § IsActive()

bool dgConstraint::IsActive | ( |  | ) | const

inline

## § IsBilateral()

bool dgConstraint::IsBilateral | ( |  | ) | const

protectedvirtual

Reimplemented in dgUpVectorConstraint, and dgBilateralConstraint.

## § IsCollidable()

bool dgConstraint::IsCollidable | ( |  | ) | const

inline

## § JacobianDerivative()

virtual dgUnsigned32 dgConstraint::JacobianDerivative | ( | dgContraintDescritor & | params | ) |

protectedpure virtual

Implemented in dgContact, NewtonUserJoint, and dgUserConstraint.

## § JointAccelerations()

virtual void dgConstraint::JointAccelerations | ( | dgJointAccelerationDecriptor *const | params | ) |

protectedpure virtual

Implemented in dgContact, and dgBilateralConstraint.

## § JointVelocityCorrection()

virtual void dgConstraint::JointVelocityCorrection | ( | dgJointAccelerationDecriptor *const | params | ) |

protectedpure virtual

Implemented in dgContact, and dgBilateralConstraint.

## § ResetMaxDOF()

void dgConstraint::ResetMaxDOF | ( |  | ) |

inlinevirtual

Reimplemented in dgContact.

## § SetBodies()

void dgConstraint::SetBodies | ( | dgBody *const | body0,
|  | dgBody *const | body1
| ) |  |

inline

## § SetCollidable()

void dgConstraint::SetCollidable | ( | bool | state | ) |

inline

## § SetDestructorCallback()

virtual void dgConstraint::SetDestructorCallback | ( | OnConstraintDestroy | destructor | ) |

pure virtual

Implemented in dgContact, and dgBilateralConstraint.

## § SetStiffness()

void dgConstraint::SetStiffness | ( | dgFloat32 | stiffness | ) |

inlinevirtual

Reimplemented in dgBilateralConstraint.

## § SetUpdateFeedbackFunction()

void dgConstraint::SetUpdateFeedbackFunction | ( | ConstraintsForceFeeback | function | ) |

inlineprotected

## § SetUserData()

void dgConstraint::SetUserData | ( | void * | userData | ) |

## Friends And Related Function Documentation

## § dgAmpInstance

friend class dgAmpInstance

friend

## § dgBodyMasterList

friend class dgBodyMasterList

friend

## § dgBroadPhaseMaterialCallbackWorkerThread

friend class dgBroadPhaseMaterialCallbackWorkerThread

friend

## § dgJacobianMemory

friend class dgJacobianMemory

friend

## § dgParallelSolverBuildJacobianMatrix

friend class dgParallelSolverBuildJacobianMatrix

friend

## § dgParallelSolverInitFeedbackUpdate

friend class dgParallelSolverInitFeedbackUpdate

friend

## § dgParallelSolverJointAcceleration

friend class dgParallelSolverJointAcceleration

friend

## § dgWorld

friend class dgWorld

friend

## § dgWorldDynamicUpdate

friend class dgWorldDynamicUpdate

friend

## Member Data Documentation

## § m_body0

dgBody* dgConstraint::m_body0

protected

## § m_body1

dgBody* dgConstraint::m_body1

protected

## § m_constId

dgUnsigned32 dgConstraint::m_constId

protected

## § m_contactActive

dgUnsigned32 dgConstraint::m_contactActive

protected

## § m_dynamicsLru

dgUnsigned32 dgConstraint::m_dynamicsLru

protected

## § m_enableCollision

dgUnsigned32 dgConstraint::m_enableCollision

protected

## § m_index

dgUnsigned32 dgConstraint::m_index

protected

## § m_link0

dgBodyMasterListRow::dgListNode* dgConstraint::m_link0

protected

## § m_link1

dgBodyMasterListRow::dgListNode* dgConstraint::m_link1

protected

## § m_maxDOF

dgUnsigned32 dgConstraint::m_maxDOF

protected

## § m_solverActive

dgUnsigned32 dgConstraint::m_solverActive

protected

## § m_updaFeedbackCallback

ConstraintsForceFeeback dgConstraint::m_updaFeedbackCallback

protected

## § m_useExactSolver

dgUnsigned32 dgConstraint::m_useExactSolver

protected

## § m_userData

void* dgConstraint::m_userData

protected

The documentation for this class was generated from the following files:

- dynamics.mod/NewtonDynamics/source/physics/dgConstraint.h
- dynamics.mod/NewtonDynamics/source/physics/dgConstraint.cpp